// based on hyper-john music playing functionality
// https://github.com/cwright017/hyper-john

const AUDIO_SRC = require('./cringe.js');

module.exports.decorateTerm = (Term, {React, notify}) => {
    return class extends React.Component {
        constructor (props, context) {
            super(props, context)
            this._onTerminal = this._onTerminal.bind(this);
            this._audio = new Audio(AUDIO_SRC);
            this._audio.onended = this._onAudioEnded.bind(this);
            this._audio.onplay = this._onAudioPlay.bind(this);
        }

        _resetAudio() {
            this._audio.pause();
            this._audio.currentTime = 0;
            clearInterval(this._audioPlaying);
        }

        _onAudioEnded () {
            this._resetAudio();            
        }

        _onTerminal (term) {
            this._div = term.div_;
            this._window = term.document_.defaultView;
        
            this._audio.play();

            if (this.props.onTerminal) {
                this.props.onTerminal(term);
            }
        }       

        componentWillUnmount () {            
            this._resetAudio();
        }

    render () {
      return React.createElement(Term, Object.assign({}, this.props, {
        onTerminal: this._onTerminal
      }))
    }
  }
}
